unit UZinc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, ImgList, ToolWin, Menus, ActnList;

type
  TMode=(All,Avl,Non,Year,Company);
  TGame=record
         Game,Country,Company,System,Year:String;
         Romname:String;
         Preview:String;
         Exists:Boolean;
         Sound:Boolean;
        end;
  TGameList=Array of TGame;

  TfrmMain = class(TForm)
    pnlFolder: TPanel;
    tvFolder: TTreeView;
    splLeft: TSplitter;
    pnlGames: TPanel;
    lvGames: TListView;
    splRight: TSplitter;
    pnlSnapshot: TPanel;
    sbMain: TStatusBar;
    ilMenu: TImageList;
    ilFolders: TImageList;
    ilSGames: TImageList;
    tbMain: TToolBar;
    pnlTop: TPanel;
    mmMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    alMain: TActionList;
    actHideFolder: TAction;
    actHideScreenshot: TAction;
    imgSnapshot: TImage;
    mnuPlay: TMenuItem;
    N1: TMenuItem;
    mnuRandom: TMenuItem;
    mnuAudit: TMenuItem;
    mnuView: TMenuItem;
    mnuToolbar: TMenuItem;
    mnuStatusbar: TMenuItem;
    mnuFolderlist: TMenuItem;
    mnuScreenshot: TMenuItem;
    N2: TMenuItem;
    mnuLargeIcons: TMenuItem;
    mnuSmallIcons: TMenuItem;
    mnuList: TMenuItem;
    mnuDetails: TMenuItem;
    mnuOptions: TMenuItem;
    mnuHelp: TMenuItem;
    actStatusbar: TAction;
    actToolbar: TAction;
    actLargeIcons: TAction;
    actSmallIcons: TAction;
    actList: TAction;
    actDetails: TAction;
    mnuSettings: TMenuItem;
    mnuAbout: TMenuItem;
    ilLogo: TImageList;
    actPlay: TAction;
    pmGames: TPopupMenu;
    Play1: TMenuItem;
    mnuProperties: TMenuItem;
    actProperties: TAction;
    N3: TMenuItem;
    mnuRandom2: TMenuItem;
    N4: TMenuItem;
    ilLGames: TImageList;
    mnuRomDirectory: TMenuItem;
    procedure actHideFolderUpdate(Sender: TObject);
    procedure actHideFolderExecute(Sender: TObject);
    procedure actHideScreenshotExecute(Sender: TObject);
    procedure actHideScreenshotUpdate(Sender: TObject);
    procedure actStatusbarExecute(Sender: TObject);
    procedure actStatusbarUpdate(Sender: TObject);
    procedure actToolbarExecute(Sender: TObject);
    procedure actToolbarUpdate(Sender: TObject);
    procedure actLargeIconsExecute(Sender: TObject);
    procedure actLargeIconsUpdate(Sender: TObject);
    procedure actListExecute(Sender: TObject);
    procedure actListUpdate(Sender: TObject);
    procedure actDetailsExecute(Sender: TObject);
    procedure actDetailsUpdate(Sender: TObject);
    procedure actSmallIconsExecute(Sender: TObject);
    procedure actSmallIconsUpdate(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure actPlayExecute(Sender: TObject);
    procedure actPlayUpdate(Sender: TObject);
    procedure mnuRandomClick(Sender: TObject);
    procedure mnuAuditClick(Sender: TObject);
    procedure actPropertiesExecute(Sender: TObject);
    procedure actPropertiesUpdate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure lvGamesDblClick(Sender: TObject);
    procedure mnuRomDirectoryClick(Sender: TObject);
    procedure lvGamesChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure tvFolderChange(Sender: TObject; Node: TTreeNode);
    procedure mnuAboutClick(Sender: TObject);
  private
    { Private-Deklarationen }
    GameList:TGameList;
    Romdir:String;
    procedure LoadConfig;
    procedure CreateLVGameList(Mode:TMode);
  public
    { Public-Deklarationen }
    procedure OpenGame(Nr:Integer);
  end;

var
  frmMain: TfrmMain;

implementation uses uziplist,filectrl,shellapi,jpeg,inifiles, UProperties, UAbout;

{$R *.DFM}

function AppendBackslash(S:String):String;
begin
 if (s='') or (s[length(s)]<>'\') then s:=s+'\';
 result:=s;
end;

function strTok(Var S:String;Token:Char=';'):String;
var posi:integer;
begin
 posi:=pos(Token,s);
 if posi=0 then begin
  result:=s;
  s:='';
 end else begin
  result:=copy(s,1,posi-1);
  delete(s,1,posi);
 end;
end;

procedure WriteDebug(S:String);
var f:textfile;
begin
 assignfile(f,'debug.txt');
 if fileexists('debug.txt') then append(f) else rewrite(f);
 writeln(f,s);
 close(f);
end;

procedure TfrmMain.LoadConfig;
var ini:TInifile;
    count,i,j:integer;
    name,rom:String;
    found,quit:Boolean;
    root,child:TTreeNode;
    zip:TZip;
    line:String;
    list:TStringList;
begin
 frmProperties.LoadSettings(-1);
 ini:=TInifile.Create(extractfilepath(Application.ExeName)+'\'+configName);
 romDir:=appendbackslash(ini.ReadString('General','Path','Roms\'));
 count:=0;quit:=false;
 repeat
  inc(count);rom:='Rom'+inttostr(Count);
  name:=ini.ReadString(Rom,'Game','');
  if name<>'' then begin
   setlength(GameList,count);
   with GameList[Count-1] do begin
    Game     := name;
    Country  := ini.ReadString(Rom,'Country','');
    Company  := ini.ReadString(Rom,'Company','');
    System   := ini.ReadString(Rom,'System','');
    Year     := ini.ReadString(Rom,'Year','');
    Sound    := ini.ReadBool(Rom,'Sound',false);
    Romname  := ini.ReadString(Rom,'Romname','');
    Preview  := ini.ReadString(Rom,'Preview',copy(Romname,1,pos('.',Romname))+'jpg');
    Romname:=RomDir+RomName;

    line:= ini.ReadString(Rom,'Files',''); // Filelist
    exists:=fileexists(romname);

    if (exists) and (line<>'') then begin
     list:=TStringlist.create;
     while line<>'' do list.add(strtok(line,',')); // Load in Stringlist

     zip:=tzip.create(romname);
     if (zip.Count>0) and (List.count>0) then begin
       exists:=false;
       for i:=0 to zip.Count-1 do
        for j:=0 to list.count-1 do
         if lowercase(zip.Items[i].filename)=lowercase(list[j]) then exists:=true;
      end;
      list.destroy;
    end;

   end;
  end else quit:=true;
 until quit;
 ini.Destroy;

 if (tvFolder.items[2].text<>'Company') then
  root:=tvFolder.Items.Insert(tvFolder.Items[2],'Company') else
  root:=tvFolder.items[2];

 root.imageindex:=3;root.SelectedIndex:=1;
 for i:=0 to high(gamelist) do begin
  found:=false;
  if root.count>0 then
   for j:=0 to root.count-1 do if root.Item[j].text=gamelist[i].company then found:=true;
  if not found then begin
   child:=tvFolder.Items.AddChild(root,gamelist[i].company);
   child.ImageIndex:=8;child.SelectedIndex:=1;
   child.StateIndex:=4;
  end;
 end;
end;

procedure TfrmMain.CreateLVGameList(Mode:TMode);

 procedure AddGame(Nr:integer);
 begin
  with lvGames.Items.Add do begin
   caption:=gamelist[nr].game;
   SubItems.add(gamelist[nr].country);
   SubItems.add(gamelist[nr].Company);
   SubItems.add(gamelist[nr].System);
   SubItems.add(gamelist[nr].Year);
   StateIndex:=Nr;
   if (gamelist[nr].exists) then begin
   if (gamelist[nr].sound) then imageindex:=0 else imageindex:=2;
   end else imageindex:=1;
  end;
 end;

var i:integer;
begin
 lvGames.Items.BeginUpdate;
 lvGames.Items.Clear;
 for i:=0 to high(gamelist) do
  case mode of
  All: AddGame(i);
  Avl: if gamelist[i].exists then AddGame(i);
  Non: if not gamelist[i].exists then AddGame(i);
  Year: if gamelist[i].year=tvFolder.Selected.Text then AddGame(i);
  Company: if gamelist[i].company=tvFolder.Selected.Text then AddGame(i);
 end;
 lvGames.Items.EndUpdate;
end;

procedure TfrmMain.OpenGame(Nr:Integer);
const value:array[false..true] of string=('no','yes');
var param:String;
begin
 frmProperties.LoadSettings(Nr);//Load Settings...
 frmProperties.CreateConfig;// Create Config
 param:=inttostr(nr+1);
// showmessage(lvgames.Items[nr].caption+' '+param);
 with frmProperties do begin
  if edDir.text<>'' then param:=param+' --roms-directory='+edDir.text;
  param:=param+' --use-sound='+value[cbSound.Checked];
  param:=param+' --sound-filter-enable='+value[cbSoundFilter.Checked];
  param:=param+' --sound-filter-cutoff='+edCutOff.text;
  param:=param+' --sound-surround-lite-enable='+value[cbSurround.Checked=true];
  param:=param+' --sound-surround-lite-multiplier='+edSurrMult.Text;
  param:=param+' --sound-stereo-exciter='+value[cbStereo.Checked=true];
  param:=param+' --use-slow-geometry='+value[cbGeometry.Checked=false];
  param:=param+' --renderer='+renderer;
  param:=param+' --use-renderer-cfg-file=renderer.cfg';
 end;
// writedebug('zinc '+param);
 ShellExecute(Handle,'Open', 'zinc.exe',Pchar(param),nil,SW_SHOW);
end;

procedure TfrmMain.actHideFolderUpdate(Sender: TObject);
begin
 actHideFolder.Checked:=pnlFolder.Visible;
end;

procedure TfrmMain.actHideFolderExecute(Sender: TObject);
begin
 splLeft.Visible:=not splLeft.Visible;
 pnlFolder.Visible:=splLeft.Visible;
end;

procedure TfrmMain.actHideScreenshotExecute(Sender: TObject);
begin
 pnlSnapshot.Visible:=not pnlSnapshot.visible;
 splRight.visible:=pnlSnapshot.Visible;
end;

procedure TfrmMain.actHideScreenshotUpdate(Sender: TObject);
begin
 actHideScreenshot.Checked:=pnlSnapshot.Visible
end;

procedure TfrmMain.actStatusbarExecute(Sender: TObject);
begin
 sbMain.Visible:=not sbMain.Visible;
end;

procedure TfrmMain.actStatusbarUpdate(Sender: TObject);
begin
 actStatusbar.Checked:=sbMain.Visible;
end;

procedure TfrmMain.actToolbarExecute(Sender: TObject);
begin
 tbMain.visible:=not tbMain.visible;
end;

procedure TfrmMain.actToolbarUpdate(Sender: TObject);
begin
 actToolbar.checked:=tbmain.visible;
end;

procedure TfrmMain.actLargeIconsExecute(Sender: TObject);
begin
 lvGames.ViewStyle:=vsIcon;
end;

procedure TfrmMain.actLargeIconsUpdate(Sender: TObject);
begin
 actLargeIcons.checked:=lvGames.ViewStyle=vsIcon;
end;

procedure TfrmMain.actListExecute(Sender: TObject);
begin
 lvGames.ViewStyle:=vsList;
end;

procedure TfrmMain.actListUpdate(Sender: TObject);
begin
 actList.Checked:=lvGames.ViewStyle=vsList;
end;

procedure TfrmMain.actDetailsExecute(Sender: TObject);
begin
 lvGames.ViewStyle:=vsReport;
end;

procedure TfrmMain.actDetailsUpdate(Sender: TObject);
begin
 actDetails.Checked:=lvGames.ViewStyle=vsReport;
end;

procedure TfrmMain.actSmallIconsExecute(Sender: TObject);
begin
 lvGames.ViewStyle:=vsSmallIcon;
end;

procedure TfrmMain.actSmallIconsUpdate(Sender: TObject);
begin
 actSmallIcons.Checked:= lvGames.ViewStyle=vsSmallIcon;
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
 close;
end;


procedure TfrmMain.actPlayExecute(Sender: TObject);
begin
 openGame(lvGames.Selected.StateIndex);
end;

procedure TfrmMain.actPlayUpdate(Sender: TObject);
begin
 actPlay.Enabled:=assigned(lvGames.Selected) and Gamelist[lvGames.Selected.StateIndex].exists;
end;

procedure TfrmMain.mnuRandomClick(Sender: TObject);
var game,count:integer;
begin
 randomize;count:=0;
 repeat
  game:=random(high(gamelist));
  inc(count);
 until (gamelist[game].exists) or (count>100);
 OpenGame(Game);
end;

procedure TfrmMain.mnuAuditClick(Sender: TObject);
begin
 LoadConfig;
 CreateLVGamelist(All);
 imgSnapShot.Picture.bitmap.Width:=illogo.width;
 imgSnapShot.Picture.bitmap.Height:=illogo.height;
 ilLogo.Draw(imgSnapShot.Picture.Bitmap.Canvas,0,0,0);
end;

procedure TfrmMain.actPropertiesExecute(Sender: TObject);
begin
 with frmProperties do begin
  loadsettings(lvGames.Selected.StateIndex);
  filename:=gamelist[lvGames.Selected.StateIndex].game;
  if showmodal=mrOK then savesettings(lvGames.Selected.StateIndex);
 end;
end;

procedure TfrmMain.actPropertiesUpdate(Sender: TObject);
begin
 actProperties.Enabled:=assigned(lvGames.Selected) and Gamelist[lvGames.Selected.StateIndex].exists;
end;

procedure TfrmMain.FormActivate(Sender: TObject);
begin
 onActivate:=nil;
 mnuAuditClick(nil);
end;

procedure TfrmMain.lvGamesDblClick(Sender: TObject);
begin
 if assigned(lvGames.Selected) then
  opengame(lvgames.Selected.stateindex);
end;

procedure TfrmMain.mnuRomDirectoryClick(Sender: TObject);
var ini:TInifile;
    dir,fname:String;
begin
 if SelectDirectory('Choose Rom-Directory', '',Dir) then
 begin
  fname:=extractfilepath(Application.ExeName)+'\'+configName;
  if not fileexists(fname) then frmProperties.mmoSetup.Lines.SaveToFile(fname);
  ini:=tinifile.create(fname);
  ini.WriteString('General','Path',dir);
  ini.destroy;
  mnuAuditClick(nil);
 end;
end;

procedure TfrmMain.lvGamesChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var fname:string;
    index:integer;
begin
 if assigned(lvgames.Selected) then begin
  index:=lvgames.Selected.StateIndex;
  fname:='Shots\'+GameList[Index].preview;
  imgSnapShot.transparent:=not fileexists(fname);
  if fileexists(fname) then
   imgSnapshot.Picture.LoadFromFile(fname) else
   begin
    imgSnapShot.Picture.bitmap.Width:=illogo.width;
    imgSnapShot.Picture.bitmap.Height:=illogo.height;
    ilLogo.Draw(imgSnapShot.Canvas,0,0,0);
   end;
  sbMain.Panels[0].Text:=GameList[index].Game;
  if GameList[index].Exists then sbMain.Panels[1].Text:='Working' else sbMain.Panels[1].Text:='ROMs missing';
 end;
end;

procedure TfrmMain.tvFolderChange(Sender: TObject; Node: TTreeNode);
begin
 if not assigned(tvFolder.Selected) then exit;
 with tvFolder do
 if (Selected.StateIndex<>-1) then
  case Selected.StateIndex of
   0:CreateLVGameList(All);
   1:CreateLVGameList(Avl);
   2:CreateLVGameList(Non);
   3:CreateLVGameList(Year);
   else CreateLVGameList(Company);
  end;
 sbMain.Panels[2].Text:=inttostr(lvGames.items.count)+' Games';
end;

procedure TfrmMain.mnuAboutClick(Sender: TObject);
begin
 frmabout.ShowModal;
end;

end.
